<html>
<head>
<title>Ogre::Log::Stream Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1Log.html">Log</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1Log_1_1Stream.html">Stream</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::Log::Stream Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::Log::Stream" -->
<p><a class="el" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a> object which targets a log.  
 <a href="classOgre_1_1Log_1_1Stream.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>&gt;</code></p>

<p><a href="classOgre_1_1Log_1_1Stream-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1Log_1_1Stream_1_1Flush.html">Flush</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Simple type to indicate a flush of the stream to the log.  <a href="structOgre_1_1Log_1_1Stream_1_1Flush.html#details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Log_1_1Stream.html#abb964da863230b1cf237756dbad019a0">Stream</a> (<a class="el" href="classOgre_1_1Log.html">Log</a> *target, <a class="el" href="group__General.html#ga124456c1616299612ac9f46e7d69268d">LogMessageLevel</a> lml, bool maskDebug)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Log_1_1Stream.html#a6fc9e8bdfbe99542e713d6dd1cab6445">Stream</a> (const <a class="el" href="classOgre_1_1Log_1_1Stream.html">Stream</a> &amp;rhs)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Log_1_1Stream.html#ae6c2f83ae8ef776ed5c7cd4ab29e6c99">~Stream</a> ()</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Log_1_1Stream.html">Stream</a> &amp;&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1Log_1_1Stream.html#ab05a9baee615031647a629216165b040">operator&lt;&lt;</a> (const T &amp;v)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Log_1_1Stream.html">Stream</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Log_1_1Stream.html#ad6c8bfec86eb1b94005d4f2df7aa7d87">operator&lt;&lt;</a> (const <a class="el" href="structOgre_1_1Log_1_1Stream_1_1Flush.html">Flush</a> &amp;v)</td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Log_1_1Stream.html#a04add6a1fbc404a391f5a165bd93b390">BaseStream</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Log.html">Log</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Log_1_1Stream.html#a6e267e43fd505f450c8f9a33c178328f">mTarget</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__General.html#ga124456c1616299612ac9f46e7d69268d">LogMessageLevel</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Log_1_1Stream.html#a22e0c049cd7aedad1f52c787684435d7">mLevel</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Log_1_1Stream.html#adae89940dde1c7d895825d7106ddbeae">mMaskDebug</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Log_1_1Stream.html#a04add6a1fbc404a391f5a165bd93b390">BaseStream</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Log_1_1Stream.html#a50b701a80b02f7ee33cc93de20773f78">mCache</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p><a class="el" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a> object which targets a log. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>A stream logger object makes it simpler to send various things to a log. You can just use the operator&lt;&lt; implementation to stream anything to the log, which is cached until a <a class="el" href="structOgre_1_1Log_1_1Stream_1_1Flush.html" title="Simple type to indicate a flush of the stream to the log.">Stream::Flush</a> is encountered, or the stream itself is destroyed, at which point the cached contents are sent to the underlying log. You can use <a class="el" href="classOgre_1_1Log.html#ad8296f1f29dbc5ba46188264fce84c4a" title="Get a stream object targeting this log.">Log::stream()</a> directly without assigning it to a local variable and as soon as the streaming is finished, the object will be destroyed and the message logged. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>You can stream control operations to this object too, such as std::setw() and std::setfill() to control formatting. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>Each <a class="el" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a> object is not thread safe, so do not pass it between threads. Multiple threads can hold their own <a class="el" href="classOgre_1_1Log_1_1Stream.html" title="Stream object which targets a log.">Stream</a> instances pointing at the same <a class="el" href="classOgre_1_1Log.html">Log</a> though and that is threadsafe. </dd></dl>

<p>Definition at line <a class="el" href="OgreLog_8h_source.html#l00199">199</a> of file <a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a04add6a1fbc404a391f5a165bd93b390"></a><!-- doxytag: member="Ogre::Log::Stream::BaseStream" ref="a04add6a1fbc404a391f5a165bd93b390" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a> <a class="el" href="classOgre_1_1Log_1_1Stream.html#a04add6a1fbc404a391f5a165bd93b390">Ogre::Log::Stream::BaseStream</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreLog_8h_source.html#l00205">205</a> of file <a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="abb964da863230b1cf237756dbad019a0"></a><!-- doxytag: member="Ogre::Log::Stream::Stream" ref="abb964da863230b1cf237756dbad019a0" args="(Log *target, LogMessageLevel lml, bool maskDebug)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Log_1_1Stream.html#abb964da863230b1cf237756dbad019a0">Ogre::Log::Stream::Stream</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Log.html">Log</a> *&#160;</td>
          <td class="paramname"><em>target</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__General.html#ga124456c1616299612ac9f46e7d69268d">LogMessageLevel</a>&#160;</td>
          <td class="paramname"><em>lml</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>maskDebug</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreLog_8h_source.html#l00213">213</a> of file <a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>.</p>

</div>
</div>
<a class="anchor" id="a6fc9e8bdfbe99542e713d6dd1cab6445"></a><!-- doxytag: member="Ogre::Log::Stream::Stream" ref="a6fc9e8bdfbe99542e713d6dd1cab6445" args="(const Stream &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Log_1_1Stream.html#abb964da863230b1cf237756dbad019a0">Ogre::Log::Stream::Stream</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Log_1_1Stream.html">Stream</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreLog_8h_source.html#l00219">219</a> of file <a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>.</p>

<p>References <a class="el" href="OgreLog_8h_source.html#l00206">mCache</a>.</p>

</div>
</div>
<a class="anchor" id="ae6c2f83ae8ef776ed5c7cd4ab29e6c99"></a><!-- doxytag: member="Ogre::Log::Stream::~Stream" ref="ae6c2f83ae8ef776ed5c7cd4ab29e6c99" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Log_1_1Stream.html#ae6c2f83ae8ef776ed5c7cd4ab29e6c99">Ogre::Log::Stream::~Stream</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreLog_8h_source.html#l00225">225</a> of file <a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ab05a9baee615031647a629216165b040"></a><!-- doxytag: member="Ogre::Log::Stream::operator&lt;&lt;" ref="ab05a9baee615031647a629216165b040" args="(const T &amp;v)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Log_1_1Stream.html">Stream</a>&amp; Ogre::Log::Stream::operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreLog_8h_source.html#l00235">235</a> of file <a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad6c8bfec86eb1b94005d4f2df7aa7d87"></a><!-- doxytag: member="Ogre::Log::Stream::operator&lt;&lt;" ref="ad6c8bfec86eb1b94005d4f2df7aa7d87" args="(const Flush &amp;v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Log_1_1Stream.html">Stream</a>&amp; Ogre::Log::Stream::operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1Log_1_1Stream_1_1Flush.html">Flush</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreLog_8h_source.html#l00241">241</a> of file <a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>.</p>

<p>References <a class="el" href="OgreString_8h_source.html#l00195">Ogre::StringUtil::BLANK</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a50b701a80b02f7ee33cc93de20773f78"></a><!-- doxytag: member="Ogre::Log::Stream::mCache" ref="a50b701a80b02f7ee33cc93de20773f78" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Log_1_1Stream.html#a04add6a1fbc404a391f5a165bd93b390">BaseStream</a> <a class="el" href="classOgre_1_1Log_1_1Stream.html#a50b701a80b02f7ee33cc93de20773f78">Ogre::Log::Stream::mCache</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreLog_8h_source.html#l00206">206</a> of file <a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>.</p>

<p>Referenced by <a class="el" href="OgreLog_8h_source.html#l00219">Stream()</a>.</p>

</div>
</div>
<a class="anchor" id="a22e0c049cd7aedad1f52c787684435d7"></a><!-- doxytag: member="Ogre::Log::Stream::mLevel" ref="a22e0c049cd7aedad1f52c787684435d7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__General.html#ga124456c1616299612ac9f46e7d69268d">LogMessageLevel</a> <a class="el" href="classOgre_1_1Log_1_1Stream.html#a22e0c049cd7aedad1f52c787684435d7">Ogre::Log::Stream::mLevel</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreLog_8h_source.html#l00203">203</a> of file <a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>.</p>

</div>
</div>
<a class="anchor" id="adae89940dde1c7d895825d7106ddbeae"></a><!-- doxytag: member="Ogre::Log::Stream::mMaskDebug" ref="adae89940dde1c7d895825d7106ddbeae" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1Log_1_1Stream.html#adae89940dde1c7d895825d7106ddbeae">Ogre::Log::Stream::mMaskDebug</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreLog_8h_source.html#l00204">204</a> of file <a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>.</p>

</div>
</div>
<a class="anchor" id="a6e267e43fd505f450c8f9a33c178328f"></a><!-- doxytag: member="Ogre::Log::Stream::mTarget" ref="a6e267e43fd505f450c8f9a33c178328f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Log.html">Log</a>* <a class="el" href="classOgre_1_1Log_1_1Stream.html#a6e267e43fd505f450c8f9a33c178328f">Ogre::Log::Stream::mTarget</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreLog_8h_source.html#l00202">202</a> of file <a class="el" href="OgreLog_8h_source.html">OgreLog.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreLog_8h_source.html">OgreLog.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:58
</p>
</body>
</html>
